// Copyright (C) 2013 Nicholas Carlson

// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

uniform mat4 Model;
uniform mat4 View;
uniform mat4 Projection;

// Convert our CIE xyY colors (which are packed in position.xy) to rgb.
vec4 CIEXYtoRGB(float x, float y)
{
    float Y = 0.5;
    float r = (3.24156*x*Y/y) - (1.53767*Y) - (0.49870*(1-x-y)*Y/y);
    float g = -(0.96920*x*Y/y) + (1.87589*Y) + (0.04155*(1-x-y)*Y/y);
    float b = (0.05562*x*Y/y) - (0.20396*Y) + (1.05686*(1-x-y)*Y/y);
    return vec4(r, g, b, 1.0);
}

vec4 position(mat4 mvp, vec4 position)
{
    VaryingColor = CIEXYtoRGB(position.x, position.y);

    return Projection * View * Model * VertexColor;
}