-- Copyright (C) 2013 Nicholas Carlson
--
-- Permission is hereby granted, free of charge, to any person obtaining a
-- copy of this software and associated documentation files (the "Software"),
-- to deal in the Software without restriction, including without limitation
-- the rights to use, copy, modify, merge, publish, distribute, sublicense,
-- and/or sell copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following conditions:
--
-- The above copyright notice and this permission notice shall be included in
-- all copies or substantial portions of the Software.
--
-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-- IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-- AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
-- DEALINGS IN THE SOFTWARE.

function love.conf(t)
  t.title = "Back-face culling with CIE xyY color! - love2d 0.9 circa Dec 6 2013"
  t.author = "Nicholas Carlson"
  
  t.console = true
  t.release = false

  t.modules.event = true
  t.modules.keyboard = true
  t.modules.mouse = true
  t.modules.timer = true
  t.modules.joystick = true
  t.modules.image = true
  t.modules.graphics = true
  t.modules.audio = true
  t.modules.math = true
  t.modules.physics = true
  t.modules.sound = true
  t.modules.font = true
  t.modules.thread = true
  t.modules.window = true


  local laptop = {
    width = 1152,
    height = 648,
    fullscreen = false,
    vsync = false,
    fsaa = 0,
    borderless = false,
    resizable = false,
    centered = true,
  }


  local desktop = {
    width = 1280,
    height = 720,
    fullscreen = false,
    vsync = false,
    fsaa = 0,
    borderless = false,
    resizable = false,
    centered = true,
  }

  local tiny = {
    width = 640,
    height = 360,
    fullscreen = false,
    vsync = false,
    fsaa = 0,
    borderless = false,
    resizable = false,
    centered = true,
  }

  local square = {
    width = 640,
    height = 640,
    fullscreen = false,
    vsync = false,
    fsaa = 0,
    borderless = false,
    resizable = false,
    centered = true,
  }

  local windowSettings = square

  t.window.width = windowSettings.width
  t.window.height = windowSettings.height
  t.window.fullscreen = windowSettings.fullscreen
  t.window.vsync = windowSettings.vsync
  t.window.fsaa = windowSettings.fsaa
  t.window.borderless = windowSettings.borderless
  t.window.resizable = windowSettings.resizable
  t.window.centered = windowSettings.centered

  gWindow = windowSettings
end